/*
 * MonthlyCalendar.java
 * 
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 */

package schedule;

import java.awt.*;
import java.awt.event.*;
import java.util.*;


/**
 *  ʬԤ饹
 *
 */
class MonthlyCalendar extends Panel {
    ScheduleEditor editor;
    GridBagLayout gbl;
    GridBagConstraints gbc;
    GregorianCalendar calendar;
    int year;
    int month;
    int day;
    Label labelYear;
    Label labelMonth;
    Button prevMonth;
    Button nextMonth;
    final int DATES = 42;
    Button date[];
    final int numDays[] ={31,28,31,30,31,30,31,31,30,31,30,31};
    
    /**
     * Button nextMonth Υꥹʡ饹
     * ˤ
     */
    class NextMonthPressed implements ActionListener{
	public void actionPerformed(ActionEvent ev){
	    month++;
	    if ( month > 11){
		month=0;
		year++;
	    }
	    showCalendar();
	}
	public NextMonthPressed(){}
    }
    
    
    /**
     * Button prevMonth Υꥹʡ饹
     * 
     */
    class PrevMonthPressed implements ActionListener{
	public void actionPerformed(ActionEvent ev){
	    month--;
	    if ( month < 0){
		month=11;
		year--;
	    }
	    showCalendar();
	}
	public PrevMonthPressed(){}
    }
    
    /**
     * Button date[] Υꥹʡ饹
     *
     */
    class DatePressed implements ActionListener {
	public void actionPerformed(ActionEvent ev){
	    Button b = (Button )ev.getSource();
	    day = (Integer.valueOf(b.getLabel())).intValue();
	    editor.dateSelected(year,month+1,day);
	    showCalendar();
	}
    }
    
    void place (Component c,int x,int y,int w,int a,int f) {
	gbc.gridx = x;
	gbc.gridy = y;
	gbc.gridwidth = w;
	gbc.anchor = a;
	gbc.fill = f;
	gbl.setConstraints(c,gbc);
	add(c,gbc);
    }
    
    /**
     * դοȿž
     *
     */
    void reverseColor(Component c){
	Color fore = c.getForeground();
	Color back = c.getBackground();
	c.setForeground(back);
	c.setBackground(fore);
    }
    /**
     *  ߤǯΥɽ
     *
     */
    void showCalendar(){
	calendar.setTime(new Date(year-1900,month,1));
	int days
	    = (calendar.isLeapYear(year) && month == 1) ? 29 :numDays[month];
	int i;
	
	if ( day > days)
	    day = days;
	
	labelYear.setText(""+year);
	labelMonth.setText(""+(month+1));
	
	for(i=0;i<DATES;i++){
	    if ( i % 7 == 0 )
		date[i].setForeground(Color.red);
	    else
		date[i].setForeground(Color.black);
	    date[i].setBackground(Color.white);
	}
	
	int today = calendar.get(Calendar.DAY_OF_WEEK)+day-2;
	reverseColor(date[today]);
	
	for(i=0;i<calendar.get(Calendar.DAY_OF_WEEK)-1;i++){
	    date[i].setLabel("");
	    date[i].setEnabled(false);
	}
	
	int j;
	for(j=1;j<=days;j++,i++){
	    date[i].setLabel(""+j);
	    date[i].setEnabled(true);
	}
	
	for(;i<DATES;i++){
	    date[i].setLabel("");
	    date[i].setEnabled(false);
	}
	
	editor.dateSelected(year,month+1,day);
    }
    
    /**
     * 
     *
     */
    public void show() {
	calendar.setTime(new Date());
	year = calendar.get(Calendar.YEAR);
	month = calendar.get(Calendar.MONTH);
	day = calendar.get(Calendar.DAY_OF_MONTH);
	showCalendar();
    }
    
    MonthlyCalendar(ScheduleEditor edit) {
	editor = edit;
	calendar = new GregorianCalendar();
	calendar.setTime(new Date());
	year = calendar.get(Calendar.YEAR);
	month = calendar.get(Calendar.MONTH);
	day = calendar.get(Calendar.DAY_OF_MONTH);
	labelYear = new Label(""+year);
	labelMonth = new Label(""+month);
	gbl = new GridBagLayout();
	gbc = new GridBagConstraints();
	date = new Button[DATES];
	int i;
	
	DatePressed datePressed = new DatePressed();
	Panel yearMonth = new Panel();
	yearMonth.add(labelYear);
	yearMonth.add(labelMonth);
	
	// 
	int row=0;
	place(yearMonth,
	      0,row++,
	      GridBagConstraints.REMAINDER,
	      GridBagConstraints.CENTER,GridBagConstraints.BOTH);
	
	place(new Label("Sun"),
	      0,row,
	      1,
	      GridBagConstraints.CENTER,GridBagConstraints.BOTH);
	
	place(new Label("Mon"),
	      1,row,
	      1,
	      GridBagConstraints.CENTER,GridBagConstraints.BOTH);
	place(new Label("Tue"),
	      2,row,
	      1,
	      GridBagConstraints.CENTER,GridBagConstraints.BOTH);
	place(new Label("Wed"),
	      3,row,
	      1,
	      GridBagConstraints.CENTER,GridBagConstraints.BOTH);
	place(new Label("Thu"),
	      4,row,
	      1,
	      GridBagConstraints.CENTER,GridBagConstraints.BOTH);
	place(new Label("Fri"),
	      5,row,
	      1,
	      GridBagConstraints.CENTER,GridBagConstraints.BOTH);
	place(new Label("Sat"),
	      6,row,
	      1,
	      GridBagConstraints.CENTER,GridBagConstraints.BOTH);
	
	row++;
	// 
	for(i=0;i<DATES;i++){
	    date[i] = new Button("");
	    date[i].addActionListener(datePressed);
	    place(date[i],
		  i%7,i/7+row,
		  1,
		  GridBagConstraints.EAST,GridBagConstraints.BOTH);
	}
	
	row+=6;
	
	//ܥ
	Panel control = new Panel();
	prevMonth = new Button("<--");
	nextMonth = new Button("-->");
	prevMonth.addActionListener(new PrevMonthPressed() );
	nextMonth.addActionListener(new NextMonthPressed() );
	
	control.add("West",prevMonth);
	control.add("East",nextMonth);
	
	
	place(control,
	      0,row,
	      GridBagConstraints.REMAINDER,
	      GridBagConstraints.CENTER,GridBagConstraints.BOTH);
	
	setLayout(gbl);
	showCalendar();
	doLayout();
    }
}
