/*
 * CipherInputStream.java
 * 
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 */

import java.io.*;
public class CipherInputStream extends FilterInputStream {
    public CipherInputStream(InputStream in){
	super(in);
    }

    public int read() throws IOException {
	int b = in.read();
	if ( b != -1 )
	    b = Cipher.decode((byte )b);
	return b;
    }

    public int read(byte b[],int off,int len) throws IOException {
	int numBytes = in.read(b,off,len);
	if ( numBytes <= 0)
	    return numBytes;
	int i;
	for(i=0;i<numBytes;i++){
	    b[ off + i] = Cipher.decode(b[off + i]);
	}
	return i;
    }

}
