/*
 * Setup.java
 * 
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 */

package hello; 

import java.rmi.*;
import java.rmi.activation.*;
import java.security.CodeSource;
import java.util.Properties;

public class Setup {
    
    public static void main(String[] args) throws Exception {
        
        System.setSecurityManager(new RMISecurityManager());
        
        Hello obj; 
	
        Properties props = (Properties)System.getProperties().clone();
        ActivationGroupID agi =
            ActivationGroup.getSystem().registerGroup(
		new ActivationGroupDesc(props));
        ActivationDesc desc =
	    new ActivationDesc(agi, "hello.HelloServer", null, null);
        
        obj = (Hello )Activatable.register(desc);
        System.out.println("Got the stub for the HelloServer");

        Naming.rebind("//localhost/HelloServer", obj);
        System.out.println("Exported HelloServer");

        System.exit(0);
    } 
} 

